function messageConverted = htstego_errdiffbin_reverse(im, NSHARES)
if nargin == 0
    im      = "airplane80";
    NSHARES = 4;
end

imfile=sprintf('%s_256gray',im);
normalInputPath=sprintf('output/%s_hterrdiffbin_regular.png',imfile);
stegoInputPath=strings(1, NSHARES);

% used only and only for properly opening files, has no role on extraction
payloadSize=2048;

for i=1:NSHARES
    stegoInputPath(i)=sprintf('output/%s_hterrdiffbin_stego_msg%d_%dof%d.png',imfile,payloadSize,i,NSHARES);
end

% used only and only for getting image dimensions, has no role on
% extraction
InormalInput=imread(normalInputPath);
[M, N]=size(InormalInput);

IstegoInput=zeros(M, N, NSHARES);
for i=1:NSHARES
    IstegoInput(:,:,i)=imread(stegoInputPath(i))/255;
end

messageExtracted = '';
messageConverted = '';

pixels=zeros(1, NSHARES);

% traverse over all stego outputs, look for different pixels and if found
% any, append 0 or 1 to messageExtracted bit string appropriately
for i=1:M
    for j=1:N
        for k=1:NSHARES
            pixels(k)=IstegoInput(i,j,k);
        end
        pSum = sum(pixels);
        % pSum == 0 -> all black, pSum == length(pixels) -> all white
        if pSum==1 % all black except one (white here)
            messageExtracted=[messageExtracted '1'];
        elseif pSum == length(pixels) - 1 % all white except one (black here)
            messageExtracted=[messageExtracted '0'];
        end
    end
end

% convert extracted bits into ASCII
for i=1:8:length(messageExtracted)-7
    messageConverted=[messageConverted char(bin2dec(messageExtracted(i:i+7)))];
end
