function messageConverted = htstego_patbin_reverse(im, NSHARES)
if nargin == 0
    im      = "airplane80";
    NSHARES = 4;
end

imfile          = sprintf('%s_256gray',im);
normalInputPath = sprintf('output/%s_htpatbin_regular.png',imfile);
stegoInputPath  = strings(1, NSHARES);

% used only and only for properly opening files, has no role on extraction
payloadSize=2048;

for i=1:NSHARES
    stegoInputPath(i)=sprintf('output/%s_htpatbin_stego_msg%d_%dof%d.png',imfile,payloadSize,i,NSHARES);
end

% used only and only for getting image dimensions, has no role on
% extraction
InormalInput = imread(normalInputPath);
[M, N]       = size(InormalInput);

IstegoInput=zeros(M, N, NSHARES);
for i=1:NSHARES
    IstegoInput(:,:,i)=imread(stegoInputPath(i));
end

messageExtracted = '';
messageConverted = '';

sums=zeros(1, NSHARES);

% traverse over all stego outputs, look for different patterns and if found
% any, append 0 or 1 to messageExtracted bit string appropriately
for i=1:3:M
    for j=1:3:N
        for k=1:NSHARES
            sums(k) = sum(sum(IstegoInput(i:i+2,j:j+2,k)))/255;
        end
        if length(unique(sums))>1
            if mode(sums)<mean(sums)
                messageExtracted=[messageExtracted '1'];
            else
                messageExtracted=[messageExtracted '0'];
            end
        end
    end
end

% convert extracted bits into ASCII
for i=1:8:length(messageExtracted)-6
    messageConverted=[messageConverted char(bin2dec(messageExtracted(i:i+7)))];
end
